; Draw horizontal color bands of every palette color while PPU
; is disabled, by changing palette entry repeatedly.
;
; hotpop.com@blargg (swap to e-mail)

	; iNES header
	.inesprg 1
	.ineschr 0
	.inesmap 0
	.inesmir 0
	
	; vectors
	.bank 1
	.org	$fffa
	.dw	nmi
	.dw	reset
	.dw	irq

	; main code
	.bank 1
	.org $e000

irq:	rti

reset:	lda	#0		; init ppu
	sta	$2000
	sta	$2001
	sta	$2005
	sta	$2006
	
wait_vbl:
	bit	$2002
	bpl	wait_vbl
	
	lda	#$84		; enable nmi
	sta	$2000
	
forever:			; code runs from nmi interrupt
	jmp	forever
	
nmi:
	ldx	#252		; delay
delay:	pha
	pla
	dex
	bne	delay
	
	ldy	#0		; color
draw_band:			; draw one color band for 3 scanlines
	ldx	#$3f		; cycle palette entry 0
	stx	$2006
	ldx	#$00
	stx	$2006
	sty	$2007
	
	ldx	#63		; delay
delay2:
	dex
	bne	delay2
	nop
	
	iny			; next color
	cpy	#$40
	bne	draw_band
	
	rti
