; Draw vertical color bands using several palette entries while PPU
; is disabled, by changing VRAM address repeatedly.
;
; hotpop.com@blargg (swap to e-mail)

	; iNES header
	.inesprg 1
	.ineschr 0
	.inesmap 0
	.inesmir 0
	
	; vectors
	.bank 1
	.org	$fffa
	.dw	nmi
	.dw	reset
	.dw	irq

	; main code
	.bank 1
	.org $e000

irq:	rti

reset:	lda	#0		; init ppu
	sta	$2000
	sta	$2001
	sta	$2005
	sta	$2006
	
wait_vbl:
	bit	$2002
	bpl	wait_vbl
	
	ldx	#$3f		; load palette
	stx	$2006
	ldx	#$00
	stx	$2006
	ldx	#$21
fill:	stx	$2007
	inx
	cpx	#$2d
	bne	fill
	ldx	#$0d
	stx	$2007
	
	lda	#$80		; enable nmi
	sta	$2000
	
forever:
	jmp	forever
	
nmi:
	ldx	#254		; delay
delay:	pha
	pla
	dex
	bne	delay
	
	lda	#200		; number of lines to do effect
	sta	<1
	lda	#$24		; 9 bits (including carry): 1 0010 0100
	sec
draw_band:
	ldx	#$3f		; change palette entry 0
	stx	$2006
	ldx	#$00
	stx	$2006
	
	ldx	$2007		; quickly increment vram address
	ldx	$2007		; to cycle through each color
	ldx	$2007
	ldx	$2007
	ldx	$2007
	ldx	$2007
	ldx	$2007
	ldx	$2007
	ldx	$2007
	ldx	$2007
	ldx	$2007
	ldx	$2007
	
	rol	a		; delay extra cycle every third iteration
	bcc	no_extra
no_extra:
	
	ldx	#8
delay2:
	dex
	bne	delay2
	
	dec	<1
	bne	draw_band
	
	rti
